Index: kernel/test/synch/workqueue2.c
===================================================================
--- kernel/test/synch/workqueue2.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ kernel/test/synch/workqueue2.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,148 @@
+/*
+ * Copyright (c) 2012 Adam Hraska
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <test.h>
+#include <arch.h>
+#include <print.h>
+#include <memstr.h>
+#include <synch/workqueue.h>
+
+
+#define WAVES 10
+#define COUNT_POW 12
+#define COUNT ((1 << COUNT_POW) - 1)
+#define WAVE_SLEEP_MS 100
+#define MAIN_POLL_SLEEP_MS 100
+#define MAIN_MAX_SLEEP_SEC 40
+
+/*
+ * Include the test implementation.
+ */
+#include "workq-test-core.h"
+
+
+/*-------------------------------------------------------------------*/
+
+static work_t basic_work;
+static int basic_done = 0;
+
+static void basic_test_work(work_t *work_item)
+{
+	basic_done = 1;
+	TPRINTF("basic_test_work()");
+}
+
+
+static void basic_test(void)
+{
+	TPRINTF("Issue a single work item.\n");
+	basic_done = 0;
+	workq_global_enqueue(&basic_work, basic_test_work);
+	
+	while (!basic_done) {
+		TPRINTF(".");
+		thread_sleep(1);
+	}
+
+	TPRINTF("\nBasic test done\n");
+}
+
+/*-------------------------------------------------------------------*/
+
+
+struct work_queue *workq = NULL;
+
+static int core_workq_enqueue(work_t *work_item, work_func_t func)
+{
+	return workq_enqueue(workq, work_item, func);
+}
+/*-------------------------------------------------------------------*/
+
+
+static const char *test_custom_workq_impl(bool stop, const char *qname)
+{
+	workq = workq_create(qname);
+	
+	if (!workq) {
+		return "Failed to create a work queue.\n";
+	}
+	
+	const char *ret = run_workq_core(stop);
+	
+	TPRINTF("Stopping work queue...\n");
+	workq_stop(workq);
+	
+	TPRINTF("Destroying work queue...\n");
+	workq_destroy(workq);
+	return ret;
+}
+
+static const char *test_custom_workq(void)
+{
+	TPRINTF("Stress testing a custom queue.\n");
+	return test_custom_workq_impl(false, "test-workq");
+}
+
+
+static const char *test_custom_workq_stop(void)
+{
+	TPRINTF("Stress testing a custom queue. Stops prematurely. "
+		"Errors are expected.\n");
+	test_custom_workq_impl(true, "test-workq-stop");
+	/* Errors are expected. */
+	return NULL;
+}
+
+
+const char *test_workqueue_all(void)
+{
+	const char *err = NULL;
+	const char *res;
+	
+	basic_test();
+	
+	res = test_custom_workq();
+	if (res) {
+		TPRINTF(res);
+		err = res;
+	}
+	
+	res = test_custom_workq_stop();
+	if (res) {
+		TPRINTF(res);
+		err = res;
+	}
+	
+	res = test_workqueue3();
+	if (res) {
+		TPRINTF(res);
+		err = res;
+	}
+
+	return err;
+}
Index: kernel/test/synch/workqueue2.def
===================================================================
--- kernel/test/synch/workqueue2.def	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ kernel/test/synch/workqueue2.def	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,6 @@
+{
+	"workqueue",
+	"Separate and system work queue stress test",
+	&test_workqueue_all,
+	true
+},
Index: kernel/test/synch/workqueue3.c
===================================================================
--- kernel/test/synch/workqueue3.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ kernel/test/synch/workqueue3.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,81 @@
+/*
+ * Copyright (c) 2012 Adam Hraska
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <test.h>
+#include <arch.h>
+#include <print.h>
+#include <memstr.h>
+#include <synch/workqueue.h>
+
+
+#define WAVES 10
+#define COUNT_POW 12
+#define COUNT ((1 << COUNT_POW) - 1)
+#define WAVE_SLEEP_MS 100
+#define MAIN_POLL_SLEEP_MS 100
+#define MAIN_MAX_SLEEP_SEC 40
+
+/*
+ * Include the test implementation.
+ */
+#include "workq-test-core.h"
+
+
+static int core_workq_enqueue(work_t *work_item, work_func_t func)
+{
+	return workq_global_enqueue(work_item, func);
+}
+
+
+
+static const char *do_test(bool exit_early)
+{
+	const char *err = NULL;
+	TPRINTF("Stress testing system queue.\n");
+	TPRINTF("First run:\n");
+	err = run_workq_core(exit_early);
+
+	if (!err) {
+		TPRINTF("\nSecond run:\n");
+		err = run_workq_core(exit_early);
+	} 
+
+	TPRINTF("Done.\n");
+	
+	return err;
+}
+
+const char *test_workqueue3(void)
+{
+	return do_test(false);
+}
+
+const char *test_workqueue3quit(void)
+{
+	return do_test(true);
+}
Index: kernel/test/synch/workqueue3.def
===================================================================
--- kernel/test/synch/workqueue3.def	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ kernel/test/synch/workqueue3.def	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,6 @@
+{
+	"workqueue3quit",
+	"Global work queue test, exits early",
+	&test_workqueue3quit,
+	true
+},
Index: kernel/test/test.c
===================================================================
--- kernel/test/test.c	(revision 21799398fb5b1afa28852a26b87fcf58caf15a28)
+++ kernel/test/test.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -41,4 +41,5 @@
 #include <avltree/avltree1.def>
 #include <btree/btree1.def>
+#include <cht/cht1.def>
 #include <debug/mips1.def>
 #include <fault/fault1.def>
@@ -50,4 +51,7 @@
 #include <synch/semaphore1.def>
 #include <synch/semaphore2.def>
+#include <synch/rcu1.def>
+#include <synch/workqueue2.def>
+#include <synch/workqueue3.def>
 #include <print/print1.def>
 #include <print/print2.def>
@@ -56,4 +60,5 @@
 #include <print/print5.def>
 #include <thread/thread1.def>
+#include <smpcall/smpcall1.def>
 	{
 		.name = NULL,
Index: kernel/test/test.h
===================================================================
--- kernel/test/test.h	(revision 21799398fb5b1afa28852a26b87fcf58caf15a28)
+++ kernel/test/test.h	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -59,4 +59,5 @@
 extern const char *test_avltree1(void);
 extern const char *test_btree1(void);
+extern const char *test_cht1(void);
 extern const char *test_mips1(void);
 extern const char *test_fault1(void);
@@ -75,4 +76,10 @@
 extern const char *test_print5(void);
 extern const char *test_thread1(void);
+extern const char *test_smpcall1(void);
+extern const char *test_workqueue_all(void);
+extern const char *test_workqueue3(void);
+extern const char *test_workqueue3quit(void);
+extern const char *test_rcu1(void);
+
 
 extern test_t tests[];
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 21799398fb5b1afa28852a26b87fcf58caf15a28)
+++ uspace/Makefile	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -61,4 +61,6 @@
 	app/nterm \
 	app/redir \
+	app/rcutest \
+	app/rcubench \
 	app/sbi \
 	app/sportdmp \
@@ -227,4 +229,5 @@
 	lib/trackmod \
 	lib/uri \
+	lib/urcu \
 	lib/usb \
 	lib/usbhost \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision 21799398fb5b1afa28852a26b87fcf58caf15a28)
+++ uspace/Makefile.common	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -156,4 +156,6 @@
 LIBGPT_PREFIX = $(LIB_PREFIX)/gpt
 
+LIBURCU_PREFIX = $(LIB_PREFIX)/urcu
+
 ifeq ($(STATIC_NEEDED),y)
 	STATIC_BUILD = y
@@ -281,4 +283,9 @@
 JOBFILE = $(LIBC_PREFIX)/../../../tools/jobfile.py
 
+ifeq ($(FUTEX_UPGRADABLE),y)
+	CFLAGS += -I$(LIBURCU_PREFIX)/
+	LIBS += $(LIBURCU_PREFIX)/liburcu.a
+endif
+
 ifeq ($(COMPILER),gcc_cross)
 	CFLAGS += $(GCC_CFLAGS) $(EXTRA_CFLAGS)
Index: uspace/app/rcubench/Makefile
===================================================================
--- uspace/app/rcubench/Makefile	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ uspace/app/rcubench/Makefile	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,41 @@
+#
+# Copyright (c) 2012 Adam Hraska
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+
+LIBS = $(LIBURCU_PREFIX)/liburcu.a
+
+EXTRA_CFLAGS += -I$(LIBURCU_PREFIX)
+	
+BINARY = rcubench
+
+SOURCES = \
+	rcubench.c
+
+include $(USPACE_PREFIX)/Makefile.common
+
Index: uspace/app/rcubench/rcubench.c
===================================================================
--- uspace/app/rcubench/rcubench.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ uspace/app/rcubench/rcubench.c	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,288 @@
+/*
+ * Copyright (c) 2012 Adam Hraska
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup test
+ * @{
+ */
+
+/**
+ * @file rcubench.c
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+#include <mem.h>
+#include <errno.h>
+#include <thread.h>
+#include <assert.h>
+#include <async.h>
+#include <fibril.h>
+#include <fibril_synch.h>
+#include <compiler/barrier.h>
+#include <futex.h>
+
+#include <rcu.h>
+
+
+/* Results are printed to this file in addition to stdout. */
+static FILE *results_fd = NULL;
+
+typedef struct bench {
+	const char *name;
+	void (*func)(struct bench *);
+	size_t iters;
+	size_t nthreads;
+	futex_t done_threads;
+	
+	futex_t bench_fut;
+} bench_t;
+
+
+
+
+static void  kernel_futex_bench(bench_t *bench)
+{
+	const size_t iters = bench->iters;
+	int val = 0;
+	
+	for (size_t i = 0; i < iters; ++i) {
+		__SYSCALL1(SYS_FUTEX_WAKEUP, (sysarg_t) &val);
+		__SYSCALL1(SYS_FUTEX_SLEEP, (sysarg_t) &val);
+	}
+}
+
+static void libc_futex_lock_bench(bench_t *bench)
+{
+	const size_t iters = bench->iters;
+	futex_t loc_fut = FUTEX_INITIALIZER;
+	
+	for (size_t i = 0; i < iters; ++i) {
+		futex_lock(&loc_fut);
+		/* no-op */
+		compiler_barrier();
+		futex_unlock(&loc_fut);
+	}
+}
+
+static void libc_futex_sema_bench(bench_t *bench)
+{
+	const size_t iters = bench->iters;
+	futex_t loc_fut = FUTEX_INITIALIZER;
+	
+	for (size_t i = 0; i < iters; ++i) {
+		futex_down(&loc_fut);
+		/* no-op */
+		compiler_barrier();
+		futex_up(&loc_fut);
+	}
+}
+
+static void thread_func(void *arg)
+{
+	bench_t *bench = (bench_t*)arg;
+	
+	bench->func(bench);
+	
+	/* Signal another thread completed. */
+	futex_up(&bench->done_threads);
+}
+
+static void run_threads_and_wait(bench_t *bench)
+{
+	assert(1 <= bench->nthreads);
+	
+	if (2 <= bench->nthreads) {
+		printf("Creating %zu additional threads...\n", bench->nthreads - 1);
+	}
+	
+	/* Create and run the first nthreads - 1 threads.*/
+	for (size_t k = 1; k < bench->nthreads; ++k) {
+		thread_id_t tid;
+		/* Also sets up a fibril for the thread. */
+		int ret = thread_create(thread_func, bench, "rcubench-t", &tid);
+		if (ret != EOK) {
+			printf("Error: Failed to create benchmark thread.\n");
+			abort();
+		}
+		thread_detach(tid);
+	}
+	
+	/* 
+	 * Run the last thread in place so that we create multiple threads
+	 * only when needed. Otherwise libc would immediately upgrade
+	 * single-threaded futexes to proper multithreaded futexes
+	 */
+	thread_func(bench);
+	
+	printf("Waiting for remaining threads to complete.\n");
+	
+	/* Wait for threads to complete. */
+	for (size_t k = 0; k < bench->nthreads; ++k) {
+		futex_down(&bench->done_threads);
+	}
+}
+
+static const char *results_txt = "/tmp/urcu-bench-results.txt";
+
+static bool open_results(void)
+{
+	results_fd = fopen(results_txt, "a");
+	return NULL != results_fd;
+}
+
+static void close_results(void)
+{
+	if (results_fd) {
+		fclose(results_fd);
+	}
+}
+
+static void print_res(const char *fmt, ... )
+{
+	va_list args;
+	
+	va_start(args, fmt);
+	vfprintf(results_fd, fmt, args);
+	va_end(args);
+	
+	va_start(args, fmt);
+	vprintf(fmt, args);
+	va_end(args);
+}
+
+static void print_usage(void)
+{
+	printf("rcubench [test-name] [k-iterations] [n-threads]\n");
+	printf("Available tests: \n");
+	printf("  sys-futex.. threads make wakeup/sleepdown futex syscalls in a loop\n");
+	printf("              but for separate variables/futex kernel objects.\n");
+	printf("  lock     .. threads lock/unlock separate futexes.\n");
+	printf("  sema     .. threads down/up separate futexes.\n");
+	printf("eg:\n");
+	printf("  rcubench sys-futex  100000 3\n");
+	printf("  rcubench lock 100000 2 ..runs futex_lock/unlock in a loop\n");
+	printf("  rcubench sema 100000 2 ..runs futex_down/up in a loop\n");
+	printf("Results are stored in %s\n", results_txt);
+}
+
+static bool parse_cmd_line(int argc, char **argv, bench_t *bench, 
+	const char **err)
+{
+	if (argc < 4) {
+		*err = "Not enough parameters";
+		return false;
+	}
+
+	futex_initialize(&bench->bench_fut, 1);
+	
+	if (0 == str_cmp(argv[1], "sys-futex")) {
+		bench->func = kernel_futex_bench;
+	} else if (0 == str_cmp(argv[1], "lock")) {
+		bench->func = libc_futex_lock_bench;
+	} else if (0 == str_cmp(argv[1], "sema")) {
+		bench->func = libc_futex_sema_bench;
+	} else {
+		*err = "Unknown test name";
+		return false;
+	}
+	
+	bench->name = argv[1];
+	
+	/* Determine iteration count. */
+	uint32_t iter_cnt = 0;
+	int ret = str_uint32_t(argv[2], NULL, 0, true, &iter_cnt);
+
+	if (ret == EOK && 1 <= iter_cnt) {
+		bench->iters = iter_cnt;
+	} else {
+		*err = "Err: Invalid number of iterations";
+		return false;
+	} 
+	
+	/* Determine thread count. */
+	uint32_t thread_cnt = 0;
+	ret = str_uint32_t(argv[3], NULL, 0, true, &thread_cnt);
+
+	if (ret == EOK && 1 <= thread_cnt && thread_cnt <= 64) {
+		bench->nthreads = thread_cnt;
+	} else {
+		*err = "Err: Invalid number of threads";
+		return false;
+	} 
+	
+	return true;
+}
+
+int main(int argc, char **argv)
+{
+	const char *err = "(error)";
+	bench_t bench;
+	
+	futex_initialize(&bench.done_threads, 0);
+	
+	if (!parse_cmd_line(argc, argv, &bench, &err)) {
+		printf("%s\n", err);
+		print_usage();
+		return -1;
+	}
+	
+	open_results();
+	
+	print_res("Running '%s' futex bench in '%zu' threads with '%zu' iterations.\n",
+		bench.name, bench.nthreads, bench.iters);
+	
+	struct timeval start, end;
+	getuptime(&start);
+	
+	run_threads_and_wait(&bench);
+	
+	getuptime(&end);
+	int64_t duration = tv_sub(&end, &start);
+	
+	uint64_t secs = (uint64_t)duration / 1000 / 1000;
+	uint64_t total_iters = (uint64_t)bench.iters * bench.nthreads;
+	uint64_t iters_per_sec = 0;
+	
+	if (0 < duration) {
+		iters_per_sec = total_iters * 1000 * 1000 / duration;
+	}
+	
+	print_res("Completed %" PRIu64 " iterations in %" PRId64  " usecs (%" PRIu64 
+		" secs); %" PRIu64 " iters/sec\n", 
+		total_iters, duration, secs, iters_per_sec);	
+
+	close_results();
+	
+	return 0;
+}
+
+
+/**
+ * @}
+ */
Index: uspace/app/rcutest/Makefile
===================================================================
--- uspace/app/rcutest/Makefile	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
+++ uspace/app/rcutest/Makefile	(revision b1c57a828cb73794beb6a309f5ec0199ca75ecc2)
@@ -0,0 +1,41 @@
+#
+# Copyright (c) 2012 Adam Hraska
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+
+LIBS = $(LIBURCU_PREFIX)/liburcu.a
+
+EXTRA_CFLAGS += -I$(LIBURCU_PREFIX)
+	
+BINARY = rcutest
+
+SOURCES = \
+	rcutest.c
+
+include $(USPACE_PREFIX)/Makefile.common
+
